﻿using CalendarNotepad.Extends;
using CalendarNotepad.Models;
using SqlSugar;

namespace CalendarNotepad
{
    public partial class WorkMain:Form
    {
        public DbContext Db { get; set; } = new DbContext();

        public WorkMain() {
            InitializeComponent();
            this.rtbMsg.EnableAutoDragDrop = true;

            //if(File.Exists(AppConfig.GetSaveFileName)) {
            //    var str = ZipExtend.GetFormFile("WorkContext.json");
            //    if(str.IsNullOrEmpty()) {
            //        return;
            //    }
            //    var wl = JsonSerializer.Deserialize<WorkUnitList>(str) ?? new WorkUnitList();
            //    if(wl == null) {
            //        return;
            //    }
            //    this.Db.Deleteable<WorkUnit>().ExecuteCommand();
            //    foreach(var i in wl) {
            //        this.Db.Insertable(i).ExecuteCommand();
            //    }
            //}



        }

        private void rtbMsg_TextChanged(object sender,EventArgs e) {

            var wd = this.mcWorkDay.SelectionStart.ToString("yyyyMMdd");
            var dr = "全天";
            var msg = this.rtbMsg.Text;
            var exp = Expressionable.Create<WorkUnit>().And(a => a.DayRange == dr && a.WorkDay == wd).ToExpression();

            var qu = this.Db.Queryable<WorkUnit>().Where(exp).ToList();
            if(qu.Any() && msg.IsNullOrEmpty()) {
                this.Db.Deleteable<WorkUnit>().Where(exp).ExecuteCommand();
                return;
            }
            if(qu.Any() && msg.IsNotNullOrEmpty()) {
                this.Db.Updateable<WorkUnit>().Where(exp).SetColumns(a => a.WorkMessage == msg).ExecuteCommand();
                return;
            }
            if(!qu.Any() && msg.IsNotNullOrEmpty()) {
                this.Db.Insertable<WorkUnit>(new WorkUnit {
                    DayRange = dr,WorkDay = wd,WorkMessage = msg,
                }).ExecuteCommand();
                return;
            }
        }

        private void WorkMain_FormClosing(object sender,FormClosingEventArgs e) {
            if(this.Db != null) {
                this.Db.Close();
                this.Db.Dispose();
            }
        }

        private void mcWorkDay_DateChanged(object sender,DateRangeEventArgs e) {
            var wd = this.mcWorkDay.SelectionStart.ToString("yyyyMMdd");
            var sr = "全天";
            var qu = this.Db.Queryable<WorkUnit>().Where(a => a.DayRange == sr && a.WorkDay == wd).ToList();
            if(qu.Any()) {
                this.rtbMsg.Text = qu.First().WorkMessage;
            }
            else {
                this.rtbMsg.Rtf = "";
            }

            Task.Factory.StartNew(() => {
                this.Invoke(() => {
                    this.mcWorkDay.BoldedDates = GetBoldDays().ToArray();
                });
            });
        }

        private List<DateTime> GetBoldDays() {
            var year = this.mcWorkDay.SelectionStart.Year;
            var month = this.mcWorkDay.SelectionStart.Month;
            var days = new List<DateTime>();
            for(int i = 1;i < 32;i++) {
                var wd = $"{year}{month.ToString("D2")}{i.ToString("D2")}";
                var qu = this.Db.Queryable<WorkUnit>().Where(a => a.WorkDay == wd && a.WorkMessage != "").ToList();
                if(qu.Any()) {
                    days.Add(new DateTime(year,month,i));
                }
            }

            return days;
        }

        private void WorkMain_Load(object sender,EventArgs e) {
            mcWorkDay_DateChanged(null,null);
        }
    }
}
